import React, { Component } from "react";
import "./App.css";

class App extends Component {
  constructor() {
    super();

    this.state = {
      rendered: false,
      height: 0,
      width: 0
    };

    window.addEventListener("resize", () => this.componentDidMount());
  }
  makeLine(edge) {
    console.log(this.refs);
    const sourceRef = this.refs[edge.source];
    const targetRef = this.refs[edge.target];
    if (!sourceRef || !targetRef) return;
    const sourceRect = sourceRef.getBoundingClientRect();
    const targetRect = targetRef.getBoundingClientRect();

    return (
      <line
        x1={sourceRect.left}
        y1={sourceRect.top}
        x2={targetRect.left}
        y2={targetRect.top}
        stroke="black"
        strokeWidth={2}
        key={Math.random()}
      />
    );
  }
  componentDidMount() {
    this.setState({
      rendered: true,
      height: this.refs.editor.getBoundingClientRect().height,
      width: this.refs.editor.getBoundingClientRect().width
    });
  }
  render() {
    const { nodes, edges } = this.props;

    return (
      <div className="editor" ref="editor">
        <svg
          className="svg"
          ref="svg"
          height={this.state.height}
          width={this.state.width}
          viewBox={`0 0 ${this.state.width} ${this.state.height}`}
        >
          {edges.map(edge => this.makeLine(edge))}
        </svg>
        <div className="boxes">
          {nodes.map(node => (
            <div className="box" ref={node}>
              {node}
            </div>
          ))}
        </div>
      </div>
    );
  }
}

export default App;
