import { Action, StateValue, StateNodeConfig, Transition } from './types';
import matchesState from './matchesState';
import mapState from './mapState';
import State from './State';
declare class StateNode<TStateKey extends string = string, TActionType extends string = string> {
    key: string;
    id: string;
    initial?: string;
    parallel?: boolean;
    states: Record<TStateKey, StateNode>;
    on?: Record<TActionType, Transition<TStateKey>>;
    parent?: StateNode;
    private _events?;
    private _relativeValue;
    private _initialState;
    constructor(config: StateNodeConfig<TStateKey, TActionType>);
    transition(state: StateValue | State, action: Action, extendedState?: any): State | undefined;
    transitionStateValue(state: StateValue | State, action: Action, extendedState?: any): StateValue | undefined;
    next(action: Action, history?: StateValue, extendedState?: any): StateValue | undefined;
    getInitialState(): StateValue | undefined;
    readonly initialState: StateValue | undefined;
    getState(relativeStateId: string): StateNode | undefined;
    readonly events: string[];
    getRelativeValue(toNode?: StateNode): StateValue;
}
declare function Machine(config: StateNodeConfig): StateNode;
export { StateNode, Machine, State, matchesState, mapState };
