import { StateNode } from './index';
import State from './State';
export declare type Action = number | string | {
    type: string;
    [key: string]: any;
};
export declare type StateKey = string | State;
export interface StateValueMap {
    [key: string]: StateValue;
}
export declare type StateValue = string | StateValueMap;
export declare type Condition = (extendedState: any) => boolean;
export declare type Transition<TStateKey extends string = string> = TStateKey | Record<TStateKey, Condition>;
export interface StateNodeConfig<TStateKey extends string = string, TActionType extends string = string> {
    initial?: string;
    states?: Record<TStateKey, StateNodeConfig>;
    parallel?: boolean;
    key?: string;
    on?: Record<TActionType, Transition<TStateKey>>;
    parent?: StateNode;
}
